/********************************************************************************************************
 * - PAN ID: 0x2176 for example										 								*
 * - Short address: 0x0000 ~ 0xFFFF changeable															*
 ********************************************************************************************************/

#include "include\include.h"

//-------------------------------------------------------------------------------------------------------
// Basic RF transmission and reception structures
//-------------------------------------------------------------------------------------------------------
BASIC_RF_RX_INFO rfRxInfo;
BASIC_RF_TX_INFO rfTxInfo;
BYTE pTxBuffer[BASIC_RF_MAX_PAYLOAD_SIZE];
BYTE pRxBuffer[BASIC_RF_MAX_PAYLOAD_SIZE];

//-------------------------------------------------------------------------------------------------------
// CLCD  Լ
//-------------------------------------------------------------------------------------------------------
void dataWrite (unsigned char dat)
{

	PORTE = dat;
	PORTB |= BM(RS);
	PORTB &= ~BM(RW);
	halWait(1000);
	PORTB |= BM(CE);
	halWait(1000);
	PORTB &= ~BM(CE);
	PORTB &= ~BM(RS);
	PORTE = 0;
}

void cmdWrite (unsigned char dat)
{
	PORTE = dat;
	PORTB &= ~BM(RS);
	PORTB &= ~BM(RW);
	halWait(1000);
	PORTB |= BM(CE);
	halWait(1000);
	PORTB &= ~BM(CE);
	PORTE = 0;
}

//-------------------------------------------------------------------------------------------------------
// CLCD ʱȭ
//-------------------------------------------------------------------------------------------------------
void LCD_INIT (void)
{
	cmdWrite(0x38);		// Function Set=> (0:0:1:DL:N:F:*:*) 8bit data lines, 2-line 5x7 dot character
	halWait(1000);        // for LCD response time

	cmdWrite(0x38);		// repeat 3 times
	halWait(1000);

	cmdWrite(0x38);		// ..
	halWait(1000);

	cmdWrite(0x06);		// Entry Mode Set=> (0:0:0:0:0:1:I/D:S) cursor direction, shift display
	halWait(1000);

	cmdWrite(0x0E);		// Display On/Off Control=> (0:0:0:0:1:D:C:B) Display On, Cursor On, Cursor blink Off
	halWait(10);

	cmdWrite(0x01);		// Clear Display=> clear display and move cursor to home position
}

//-------------------------------------------------------------------------------------------------------
//	̺갡  Ÿ  ó Լ
//-------------------------------------------------------------------------------------------------------
BASIC_RF_RX_INFO* basicRfReceivePacket(BASIC_RF_RX_INFO *pRRI) 
{
	unsigned char rfrxdata;

//-------------------------------------------------------------------------------------------------------
//	pRRI->pPayload[] : ̺κ  Ÿ ó
//-------------------------------------------------------------------------------------------------------

	if(pRRI->srcAddr == 0x0002) // slave0κ  Ÿ̸..
	{
		rfrxdata = pRRI->pPayload[0]; //  ADC (簪)

		// LCD ޼  (簪 ƽŰ ȯؾ..  ! ãƺô..
		cmdWrite(0x01);	//Clear display and Cursor at home in CLCD
		dataWrite('M'); dataWrite('e'); dataWrite('s'); dataWrite('u'); dataWrite('r'); dataWrite('e'); dataWrite('d'); dataWrite(' ');
		dataWrite('P'); dataWrite('r'); dataWrite('e'); dataWrite('s'); dataWrite('s'); dataWrite('u'); dataWrite('r'); dataWrite('e');
		cmdWrite(0xC0);	// Cursor at 2nd line in CLCD
		dataWrite('S'); dataWrite('l'); dataWrite('a'); dataWrite('v'); dataWrite('e'); dataWrite('0'); dataWrite(':'); dataWrite(' ');
		dataWrite('1'); dataWrite('0'); dataWrite('0'); dataWrite('g'); dataWrite(' '); dataWrite(' '); dataWrite(' '); dataWrite(' ');
	}
	else if(pRRI->srcAddr == 0x0003) // slave1κ  Ÿ̸..
	{

	}
	else if(pRRI->srcAddr == 0x0004) // slave2κ  Ÿ̸..
	{

	}

	return pRRI;

} // basicRfReceivePacket

//-------------------------------------------------------------------------------------------------------
//	main Լ
//-------------------------------------------------------------------------------------------------------
void main(void) 
{
	unsigned int srcaddr;

//-------------------------------------------------------------------------------------------------------
// I/OƮ, ATmega128 ġ  ֺġ ʱȭ
//-------------------------------------------------------------------------------------------------------
	PORT_INIT();
	SPI_INIT();
	LCD_INIT();

//-------------------------------------------------------------------------------------------------------
// source address 
//-------------------------------------------------------------------------------------------------------
	srcaddr = 0x0001; //  巹 0x0001 ( ..)

//-------------------------------------------------------------------------------------------------------
// ä  Pan ID 
//-------------------------------------------------------------------------------------------------------
	basicRfInit(&rfRxInfo, 26, 0x2176, srcaddr); // 26 ä , Pan ID = 0x2176( ..)

//-------------------------------------------------------------------------------------------------------
// ۵Ÿ ũ 
//-------------------------------------------------------------------------------------------------------
	rfTxInfo.length = 10; // 10 Ʈ ( ..)

//-------------------------------------------------------------------------------------------------------
// ACK   
//-------------------------------------------------------------------------------------------------------
	rfTxInfo.ackRequest = TRUE;

	rfTxInfo.pPayload = pTxBuffer;
	rfRxInfo.pPayload = pRxBuffer;

//-------------------------------------------------------------------------------------------------------
// ۵Ÿ ʱȭ
//-------------------------------------------------------------------------------------------------------
	for (unsigned char n = 0; n < 10; n++) 
	{
		pTxBuffer[n] = 0; // ۽  Ŭ
	}

	// Turn on RX mode
	basicRfReceiveOn();

//-------------------------------------------------------------------------------------------------------
// CLCD ʱȭ
//-------------------------------------------------------------------------------------------------------
	cmdWrite(0x01);	//Clear display and Cursor at home in CLCD
	dataWrite('<'); dataWrite(' '); dataWrite('Z'); dataWrite('B'); dataWrite('M'); dataWrite(' '); dataWrite(' '); dataWrite('T');
	dataWrite('R'); dataWrite('A'); dataWrite('I'); dataWrite('N'); dataWrite('E'); dataWrite('R'); dataWrite(' '); dataWrite('>');
	cmdWrite(0xC0);	// Cursor at 2nd line in CLCD
	dataWrite('O'); dataWrite('L'); dataWrite('m'); dataWrite('i'); dataWrite('c'); dataWrite('r'); dataWrite('o'); dataWrite('w');
	dataWrite('a'); dataWrite('v'); dataWrite('e'); dataWrite('s'); dataWrite(' '); dataWrite('C'); dataWrite('o'); dataWrite('.');

	while(1) //  ݺ
	{
		for(unsigned char i = 0; i < 3; i++) // slave0 -> slave1 -> slave2 -> slave0 -> ... ȯ
		{
//-------------------------------------------------------------------------------------------------------
// ̺꿡  Ÿ  (۵Ÿ ũ  ŭ)
//-------------------------------------------------------------------------------------------------------
			pTxBuffer[0] = 0x01; //  .. з ؼ ϶ ڵ
//			pTxBuffer[1] = 0x02;
//			pTxBuffer[2] = 0x03;
//			...
//			pTxBuffer[9] = 0x09;

//-------------------------------------------------------------------------------------------------------
// destination address 
//-------------------------------------------------------------------------------------------------------
			rfTxInfo.destAddr = i + 0x0002; //  ̺ 巹 ( ..)

			// ߻!!
			basicRfSendPacket(&rfTxInfo); 

			// ̺갡 ó Ϸϰ   !! ʿ信    ..
			halWait(50000); 

		} // for

	} // while(1)

} // main()
